diff --git a/build/pymake/mkformat.py b/build/pymake/mkformat.py
index 41dd761b2f..29e0407e47 100755
--- a/build/pymake/mkformat.py
+++ b/build/pymake/mkformat.py
@@ -6,8 +6,8 @@ import pymake.parser
 filename = sys.argv[1]
 source = None
 
-with open(filename, 'rU') as fh:
+with open(filename) as fh:
     source = fh.read()
 
 statements = pymake.parser.parsestring(source, filename)
-print statements.to_source()
+print(statements.to_source())
diff --git a/build/pymake/mkparse.py b/build/pymake/mkparse.py
index 253683948a..aa94b81bab 100755
--- a/build/pymake/mkparse.py
+++ b/build/pymake/mkparse.py
@@ -4,9 +4,9 @@ import sys
 import pymake.parser
 
 for f in sys.argv[1:]:
-    print "Parsing %s" % f
-    fd = open(f, 'rU')
+    print("Parsing %s" % f)
+    fd = open(f)
     s = fd.read()
     fd.close()
     stmts = pymake.parser.parsestring(s, f)
-    print stmts
+    print(stmts)
diff --git a/build/pymake/pymake/builtins.py b/build/pymake/pymake/builtins.py
index eb6f2e11bd..1ab3328195 100644
--- a/build/pymake/pymake/builtins.py
+++ b/build/pymake/pymake/builtins.py
@@ -2,7 +2,7 @@
 import errno, sys, os, shutil, time
 from getopt import getopt, GetoptError
 
-from process import PythonException
+from .process import PythonException
 
 __all__ = ["mkdir", "rm", "sleep", "touch"]
 
@@ -13,8 +13,8 @@ def mkdir(args):
   """
   try:
     opts, args = getopt(args, "p", ["parents"])
-  except GetoptError, e:
-    raise PythonException, ("mkdir: %s" % e, 1)
+  except GetoptError as e:
+    raise PythonException("mkdir: %s" % e, 1)
   parents = False
   for o, a in opts:
     if o in ('-p', '--parents'):
@@ -25,11 +25,11 @@ def mkdir(args):
         os.makedirs(f)
       else:
         os.mkdir(f)
-    except OSError, e:
+    except OSError as e:
       if e.errno == errno.EEXIST and parents:
         pass
       else:
-        raise PythonException, ("mkdir: %s" % e, 1)
+        raise PythonException("mkdir: %s" % e, 1)
 
 def rm(args):
   """
@@ -38,8 +38,8 @@ def rm(args):
   """
   try:
     opts, args = getopt(args, "rRf", ["force", "recursive"])
-  except GetoptError, e:
-    raise PythonException, ("rm: %s" % e, 1)
+  except GetoptError as e:
+    raise PythonException("rm: %s" % e, 1)
   force = False
   recursive = False
   for o, a in opts:
@@ -50,7 +50,7 @@ def rm(args):
   for f in args:
     if os.path.isdir(f):
       if not recursive:
-        raise PythonException, ("rm: cannot remove '%s': Is a directory" % f, 1)
+        raise PythonException("rm: cannot remove '%s': Is a directory" % f, 1)
       else:
         shutil.rmtree(f, force)
     elif os.path.exists(f):
@@ -58,9 +58,9 @@ def rm(args):
         os.unlink(f)
       except:
         if not force:
-          raise PythonException, ("rm: failed to remove '%s': %s" % (f, sys.exc_info()[0]), 1)
+          raise PythonException("rm: failed to remove '{}': {}".format(f, sys.exc_info()[0]), 1)
     elif not force:
-      raise PythonException, ("rm: cannot remove '%s': No such file or directory" % f, 1)
+      raise PythonException("rm: cannot remove '%s': No such file or directory" % f, 1)
 
 def sleep(args):
     """
@@ -70,7 +70,7 @@ def sleep(args):
     values = {'s': 1, 'm': 60, 'h': 3600, 'd': 86400}
     for a in args:
         multiplier = 1
-        for k, v in values.iteritems():
+        for k, v in values.items():
             if a.endswith(k):
                 a = a[:-1]
                 multiplier = v
@@ -79,7 +79,7 @@ def sleep(args):
             f = float(a)
             total += f * multiplier
         except ValueError:
-            raise PythonException, ("sleep: invalid time interval '%s'" % a, 1)
+            raise PythonException("sleep: invalid time interval '%s'" % a, 1)
     time.sleep(total)
 
 def touch(args):
@@ -88,16 +88,16 @@ def touch(args):
     """
     try:
         opts, args = getopt(args, "t:")
-    except GetoptError, e:
-        raise PythonException, ("touch: %s" % e, 1)
+    except GetoptError as e:
+        raise PythonException("touch: %s" % e, 1)
     opts = dict(opts)
     times = None
     if '-t' in opts:
         import re
         from time import mktime, localtime
-        m = re.match('^(?P<Y>(?:\d\d)?\d\d)?(?P<M>\d\d)(?P<D>\d\d)(?P<h>\d\d)(?P<m>\d\d)(?:\.(?P<s>\d\d))?$', opts['-t'])
+        m = re.match(r'^(?P<Y>(?:\d\d)?\d\d)?(?P<M>\d\d)(?P<D>\d\d)(?P<h>\d\d)(?P<m>\d\d)(?:\.(?P<s>\d\d))?$', opts['-t'])
         if not m:
-            raise PythonException, ("touch: invalid date format '%s'" % opts['-t'], 1)
+            raise PythonException("touch: invalid date format '%s'" % opts['-t'], 1)
         def normalized_field(m, f):
             if f == 'Y':
                 if m.group(f) is None:
diff --git a/build/pymake/pymake/command.py b/build/pymake/pymake/command.py
index cd68e4fdb2..3d18a2cc12 100644
--- a/build/pymake/pymake/command.py
+++ b/build/pymake/pymake/command.py
@@ -62,7 +62,7 @@ def parsemakeflags(env):
     return opts
 
 def _version(*args):
-    print """pymake: GNU-compatible make program
+    print("""pymake: GNU-compatible make program
 Copyright (C) 2009 The Mozilla Foundation <http://www.mozilla.org/>
 This is free software; see the source for copying conditions.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
@@ -71,7 +71,7 @@ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-DEALINGS IN THE SOFTWARE."""
+DEALINGS IN THE SOFTWARE.""")
 
 _log = logging.getLogger('pymake.execution')
 
@@ -95,7 +95,7 @@ class _MakeContext(object):
 
     def remakecb(self, remade, error=None):
         if error is not None:
-            print error
+            print(error)
             self.context.defer(self.cb, 2)
             return
 
@@ -124,15 +124,15 @@ class _MakeContext(object):
                     self.makefile.include(f)
                 self.makefile.finishparsing()
                 self.makefile.remakemakefiles(self.remakecb)
-            except util.MakeError, e:
-                print e
+            except util.MakeError as e:
+                print(e)
                 self.context.defer(self.cb, 2)
 
             return
 
         if len(self.targets) == 0:
             if self.makefile.defaulttarget is None:
-                print "No target specified and no default target found."
+                print("No target specified and no default target found.")
                 self.context.defer(self.cb, 2)
                 return
 
@@ -154,7 +154,7 @@ class _MakeContext(object):
 
         if not len(self.realtargets):
             if self.options.printdir:
-                print "make.py[%i]: Leaving directory '%s'" % (self.makelevel, self.workdir)
+                print("make.py[%i]: Leaving directory '%s'" % (self.makelevel, self.workdir))
             sys.stdout.flush()
 
             self.context.defer(self.cb, 0)
@@ -255,24 +255,24 @@ def main(args, env, cwd, cb):
         context = process.getcontext(options.jobcount)
 
         if options.printdir:
-            print "make.py[%i]: Entering directory '%s'" % (makelevel, workdir)
+            print("make.py[%i]: Entering directory '%s'" % (makelevel, workdir))
             sys.stdout.flush()
 
         if len(options.makefiles) == 0:
             if os.path.exists(util.normaljoin(workdir, 'Makefile')):
                 options.makefiles.append('Makefile')
             else:
-                print "No makefile found"
+                print("No makefile found")
                 cb(2)
                 return
 
         ostmts, targets, overrides = parserdata.parsecommandlineargs(arguments)
 
         _MakeContext(makeflags, makelevel, workdir, context, env, targets, options, ostmts, overrides, cb)
-    except (util.MakeError), e:
-        print e
+    except (util.MakeError) as e:
+        print(e)
         if options.printdir:
-            print "make.py[%i]: Leaving directory '%s'" % (makelevel, workdir)
+            print("make.py[%i]: Leaving directory '%s'" % (makelevel, workdir))
         sys.stdout.flush()
         cb(2)
         return
diff --git a/build/pymake/pymake/data.py b/build/pymake/pymake/data.py
index dcd7e92258..fc67e91d0f 100644
--- a/build/pymake/pymake/data.py
+++ b/build/pymake/pymake/data.py
@@ -3,13 +3,11 @@ A representation of makefile data structures.
 """
 
 import logging, re, os, sys
-import parserdata, parser, functions, process, util, implicit
+from . import parserdata, parser, functions, process, util, implicit
 from cStringIO import StringIO
+from functools import reduce
 
-if sys.version_info[0] < 3:
-    str_type = basestring
-else:
-    str_type = str
+str_type = str
 
 _log = logging.getLogger('pymake.data')
 
@@ -69,7 +67,7 @@ def _if_else(c, t, f):
     return f()
 
 
-class BaseExpansion(object):
+class BaseExpansion:
     """Base class for expansions.
 
     A make expansion is the parsed representation of a string, which may
@@ -95,8 +93,7 @@ class BaseExpansion(object):
         child expansions and extract all functions in the tree.
         """
         # An empty generator. Yeah, it's weird.
-        for x in []:
-            yield x
+        yield from []
 
     def variable_references(self, descend=False):
         """Obtain all variable references in this expansion.
@@ -186,7 +183,7 @@ class StringExpansion(BaseExpansion):
         return self.s, False
 
     def __repr__(self):
-        return "Exp<%s>(%r)" % (self.loc, self.s)
+        return "Exp<{}>({!r})".format(self.loc, self.s)
 
     def __eq__(self, other):
         """We only compare the string contents."""
@@ -355,11 +352,10 @@ class Expansion(BaseExpansion, list):
 
             if descend:
                 for exp in e.expansions(descend=True):
-                    for f in exp.functions(descend=True):
-                        yield f
+                    yield from exp.functions(descend=True)
 
     def __repr__(self):
-        return "<Expansion with elements: %r>" % ([e for e, isfunc in self],)
+        return "<Expansion with elements: {!r}>".format([e for e, isfunc in self])
 
     def to_source(self, escape_variables=False, escape_comments=False):
         parts = []
@@ -405,7 +401,7 @@ class Expansion(BaseExpansion, list):
         if len(a) != len(b):
             return False
 
-        for i in xrange(len(self)):
+        for i in range(len(self)):
             e1, is_func1 = a[i]
             e2, is_func2 = b[i]
 
@@ -423,7 +419,7 @@ class Expansion(BaseExpansion, list):
     def __ne__(self, other):
         return not self.__eq__(other)
 
-class Variables(object):
+class Variables:
     """
     A mapping from variable names to variables. Variables have flavor, source, and value. The value is an 
     expansion object.
@@ -447,7 +443,7 @@ class Variables(object):
         self.parent = parent
 
     def readfromenvironment(self, env):
-        for k, v in env.iteritems():
+        for k, v in env.items():
             self.set(k, self.FLAVOR_RECURSIVE, self.SOURCE_ENVIRONMENT, v)
 
     def get(self, name, expand=True):
@@ -462,7 +458,7 @@ class Variables(object):
         flavor, source, valuestr, valueexp = self._map.get(name, (None, None, None, None))
         if flavor is not None:
             if expand and flavor != self.FLAVOR_SIMPLE and valueexp is None:
-                d = parser.Data.fromstring(valuestr, parserdata.Location("Expansion of variables '%s'" % (name,), 1, 0))
+                d = parser.Data.fromstring(valuestr, parserdata.Location("Expansion of variables '{}'".format(name), 1, 0))
                 valueexp, t, o = parser.parsemakesyntax(d, 0, (), parser.iterdata)
                 self._map[name] = flavor, source, valuestr, valueexp
 
@@ -495,7 +491,7 @@ class Variables(object):
             if flavor == self.FLAVOR_RECURSIVE:
                 val = valueexp
             else:
-                val = Expansion.fromstring(valuestr, "Expansion of variable '%s'" % (name,))
+                val = Expansion.fromstring(valuestr, "Expansion of variable '{}'".format(name))
 
             return flavor, source, val
 
@@ -512,7 +508,7 @@ class Variables(object):
         prevflavor, prevsource, prevvalue = self.get(name)
         if prevsource is not None and source > prevsource and not force:
             # TODO: give a location for this warning
-            _log.info("not setting variable '%s', set by higher-priority source to value '%s'" % (name, prevvalue))
+            _log.info("not setting variable '{}', set by higher-priority source to value '{}'".format(name, prevvalue))
             return
 
         self._map[name] = flavor, source, value, None
@@ -531,7 +527,7 @@ class Variables(object):
             return
 
         if prevflavor == self.FLAVOR_SIMPLE:
-            d = parser.Data.fromstring(value, parserdata.Location("Expansion of variables '%s'" % (name,), 1, 0))
+            d = parser.Data.fromstring(value, parserdata.Location("Expansion of variables '{}'".format(name), 1, 0))
             valueexp, t, o = parser.parsemakesyntax(d, 0, (), parser.iterdata)
 
             val = valueexp.resolvestr(makefile, variables, [name])
@@ -547,13 +543,13 @@ class Variables(object):
             self.set(k, flavor, source, value)
 
     def __iter__(self):
-        for k, (flavor, source, value, valueexp) in self._map.iteritems():
+        for k, (flavor, source, value, valueexp) in self._map.items():
             yield k, flavor, source, value
 
     def __contains__(self, item):
         return item in self._map
 
-class Pattern(object):
+class Pattern:
     """
     A pattern is a string, possibly with a % substitution character. From the GNU make manual:
 
@@ -561,7 +557,7 @@ class Pattern(object):
     would otherwise quote '%' charcters can be quoted with more backslashes. Backslashes that
     quote '%' characters or other backslashes are removed from the pattern before it is compared t
     file names or has a stem substituted into it. Backslashes that are not in danger of quoting '%'
-    characters go unmolested. For example, the pattern the\%weird\\%pattern\\ has `the%weird\' preceding
+    characters go unmolested. For example, the pattern the\\%weird\\%pattern\\ has `the%weird\' preceding
     the operative '%' character, and 'pattern\\' following it. The final two backslashes are left alone
     because they cannot affect any '%' character.
 
@@ -658,7 +654,7 @@ class Pattern(object):
         stem = self.match(word)
         if stem is None:
             if mustmatch:
-                raise DataError("target '%s' doesn't match pattern" % (word,))
+                raise DataError("target '{}' doesn't match pattern".format(word))
             return word
 
         if not self.ispattern():
@@ -668,7 +664,7 @@ class Pattern(object):
         return Pattern(replacement).resolve('', stem)
 
     def __repr__(self):
-        return "<Pattern with data %r>" % (self.data,)
+        return "<Pattern with data {!r}>".format(self.data)
 
     _backre = re.compile(r'[%\\]')
     def __str__(self):
@@ -677,7 +673,7 @@ class Pattern(object):
 
         return self._backre.sub(r'\\\1', self.data[0]) + '%' + self.data[1]
 
-class RemakeTargetSerially(object):
+class RemakeTargetSerially:
     __slots__ = ('target', 'makefile', 'indent', 'rlist')
 
     def __init__(self, target, makefile, indent, rlist):
@@ -722,7 +718,7 @@ class RemakeTargetSerially(object):
         else:
             self.rlist[0].resolvedeps(True, self.resolvecb)
 
-class RemakeTargetParallel(object):
+class RemakeTargetParallel:
     __slots__ = ('target', 'makefile', 'indent', 'rlist', 'rulesremaining', 'currunning')
 
     def __init__(self, target, makefile, indent, rlist):
@@ -793,7 +789,7 @@ class RemakeTargetParallel(object):
         self.currunning = False
         self.runnext()
 
-class RemakeRuleContext(object):
+class RemakeRuleContext:
     def __init__(self, target, makefile, rule, deps,
                  targetstack, avoidremakeloop):
         self.target = target
@@ -864,7 +860,7 @@ class RemakeRuleContext(object):
         assert error in (True, False)
 
         if error:
-            print "<%s>: Found error" % self.target.target
+            print("<%s>: Found error" % self.target.target)
             self.error = True
         if didanything:
             self.didanything = True
@@ -949,8 +945,8 @@ class RemakeRuleContext(object):
             self.target.didanything = True
             try:
                 self.commands = [c for c in self.rule.getcommands(self.target, self.makefile)]
-            except util.MakeError, e:
-                print e
+            except util.MakeError as e:
+                print(e)
                 sys.stdout.flush()
                 cb(error=True)
                 return
@@ -963,7 +959,7 @@ MAKESTATE_NONE = 0
 MAKESTATE_FINISHED = 1
 MAKESTATE_WORKING = 2
 
-class Target(object):
+class Target:
     """
     An actual (non-pattern) target.
 
@@ -1027,7 +1023,7 @@ class Target(object):
 
         candidates = [] # list of PatternRuleInstance
 
-        hasmatch = util.any((r.hasspecificmatch(file) for r in makefile.implicitrules))
+        hasmatch = util.any(r.hasspecificmatch(file) for r in makefile.implicitrules)
 
         for r in makefile.implicitrules:
             if r in rulestack:
@@ -1109,7 +1105,7 @@ class Target(object):
         assert makefile.parsingfinished
 
         if self.target in targetstack:
-            raise ResolutionError("Recursive dependency: %s -> %s" % (
+            raise ResolutionError("Recursive dependency: {} -> {}".format(
                     " -> ".join(targetstack), self.target))
 
         targetstack = targetstack + [self.target]
@@ -1136,9 +1132,9 @@ class Target(object):
         # depend on it are always out of date. This is like .FORCE but more
         # compatible with other makes.
         # Otherwise, we don't know how to make it.
-        if not len(self.rules) and self.mtime is None and not util.any((len(rule.prerequisites) > 0
-                                                                        for rule in self.rules)):
-            raise ResolutionError("No rule to make target '%s' needed by %r" % (self.target,
+        if not len(self.rules) and self.mtime is None and not util.any(len(rule.prerequisites) > 0
+                                                                        for rule in self.rules):
+            raise ResolutionError("No rule to make target '{}' needed by {!r}".format(self.target,
                                                                                 targetstack))
 
         if recursive:
@@ -1283,9 +1279,9 @@ class Target(object):
 
         try:
             self.resolvedeps(makefile, targetstack, [], False)
-        except util.MakeError, e:
+        except util.MakeError as e:
             if printerror:
-                print e
+                print(e)
             self.error = True
             self.notifydone(makefile)
             return
@@ -1334,8 +1330,8 @@ def filepart(p):
 
 def setautomatic(v, name, plist):
     v.set(name, Variables.FLAVOR_SIMPLE, Variables.SOURCE_AUTOMATIC, ' '.join(plist))
-    v.set(name + 'D', Variables.FLAVOR_SIMPLE, Variables.SOURCE_AUTOMATIC, ' '.join((dirpart(p) for p in plist)))
-    v.set(name + 'F', Variables.FLAVOR_SIMPLE, Variables.SOURCE_AUTOMATIC, ' '.join((filepart(p) for p in plist)))
+    v.set(name + 'D', Variables.FLAVOR_SIMPLE, Variables.SOURCE_AUTOMATIC, ' '.join(dirpart(p) for p in plist))
+    v.set(name + 'F', Variables.FLAVOR_SIMPLE, Variables.SOURCE_AUTOMATIC, ' '.join(filepart(p) for p in plist))
 
 def setautomaticvariables(v, makefile, target, prerequisites):
     prtargets = [makefile.gettarget(p) for p in prerequisites]
@@ -1387,7 +1383,7 @@ def findmodifiers(command):
     modset = set(command[:-len(realcommand)])
     return realcommand, '@' in modset, '+' in modset, '-' in modset, '%' in modset
 
-class _CommandWrapper(object):
+class _CommandWrapper:
     def __init__(self, cline, ignoreErrors, loc, context, **kwargs):
         self.ignoreErrors = ignoreErrors
         self.loc = loc
@@ -1397,7 +1393,7 @@ class _CommandWrapper(object):
 
     def _cb(self, res):
         if res != 0 and not self.ignoreErrors:
-            print "%s: command '%s' failed, return code %i" % (self.loc, self.cline, res)
+            print("%s: command '%s' failed, return code %i" % (self.loc, self.cline, res))
             self.usercb(error=True)
         else:
             self.usercb(error=False)
@@ -1412,7 +1408,7 @@ class _NativeWrapper(_CommandWrapper):
         _CommandWrapper.__init__(self, cline, ignoreErrors, loc, context,
                                  **kwargs)
         if pycommandpath:
-            self.pycommandpath = re.split('[%s\s]+' % os.pathsep,
+            self.pycommandpath = re.split(r'[%s\s]+' % os.pathsep,
                                           pycommandpath)
         else:
             self.pycommandpath = None
@@ -1421,7 +1417,7 @@ class _NativeWrapper(_CommandWrapper):
         # get the module and method to call
         parts, badchar = process.clinetoargv(self.cline, self.kwargs['cwd'])
         if parts is None:
-            raise DataError("native command '%s': shell metacharacter '%s' in command line" % (self.cline, badchar), self.loc)
+            raise DataError("native command '{}': shell metacharacter '{}' in command line".format(self.cline, badchar), self.loc)
         if len(parts) < 2:
             raise DataError("native command '%s': no method name specified" % self.cline, self.loc)
         module = parts[0]
@@ -1447,7 +1443,7 @@ def getcommandsforrule(rule, target, makefile, prerequisites, stem):
             if (isHidden or makefile.silent) and not makefile.justprint:
                 echo = None
             else:
-                echo = "%s$ %s" % (c.loc, cline)
+                echo = "{}$ {}".format(c.loc, cline)
             if not isNative:
                 yield _CommandWrapper(cline, ignoreErrors=ignoreErrors, env=env, cwd=makefile.workdir, loc=c.loc, context=makefile.context,
                                       echo=echo, justprint=makefile.justprint)
@@ -1461,7 +1457,7 @@ def getcommandsforrule(rule, target, makefile, prerequisites, stem):
                                      echo=echo, justprint=makefile.justprint,
                                      pycommandpath=e)
 
-class Rule(object):
+class Rule:
     """
     A rule contains a list of prerequisites and a list of commands. It may also
     contain rule-specific variables. This rule may be associated with multiple targets.
@@ -1496,7 +1492,7 @@ class Rule(object):
         return getcommandsforrule(self, target, makefile, prereqs, stem=None)
         # TODO: $* in non-pattern rules?
 
-class PatternRuleInstance(object):
+class PatternRuleInstance:
     weakdeps = False
 
     """
@@ -1520,12 +1516,12 @@ class PatternRuleInstance(object):
         return getcommandsforrule(self, target, makefile, self.prerequisites, stem=self.dir + self.stem)
 
     def __str__(self):
-        return "Pattern rule at %s with stem '%s', matchany: %s doublecolon: %s" % (self.loc,
+        return "Pattern rule at {} with stem '{}', matchany: {} doublecolon: {}".format(self.loc,
                                                                                     self.dir + self.stem,
                                                                                     self.ismatchany,
                                                                                     self.doublecolon)
 
-class PatternRule(object):
+class PatternRule:
     """
     An implicit rule or static pattern rule containing target patterns, prerequisite patterns,
     and a list of commands.
@@ -1543,7 +1539,7 @@ class PatternRule(object):
         self.commands.append(c)
 
     def ismatchany(self):
-        return util.any((t.ismatchany() for t in self.targetpatterns))
+        return util.any(t.ismatchany() for t in self.targetpatterns)
 
     def hasspecificmatch(self, file):
         for p in self.targetpatterns:
@@ -1577,7 +1573,7 @@ class PatternRule(object):
     def prerequisitesforstem(self, dir, stem):
         return [p.resolve(dir, stem) for p in self.prerequisites]
 
-class _RemakeContext(object):
+class _RemakeContext:
     def __init__(self, makefile, cb):
         self.makefile = makefile
         self.included = [(makefile.gettarget(f), required)
@@ -1591,7 +1587,7 @@ class _RemakeContext(object):
         assert error in (True, False)
 
         if error and self.required:
-            print "Error remaking makefiles (ignored)"
+            print("Error remaking makefiles (ignored)")
 
         if len(self.toremake):
             target, self.required = self.toremake.pop(0)
@@ -1608,7 +1604,7 @@ class _RemakeContext(object):
 
             self.cb(remade=False)
 
-class Makefile(object):
+class Makefile:
     """
     The top-level data structure for makefile execution. It holds Targets, implicit rules, and other
     state data.
@@ -1678,7 +1674,7 @@ class Makefile(object):
         self.variables.set('MAKECMDGOALS', Variables.FLAVOR_SIMPLE,
                            Variables.SOURCE_AUTOMATIC, ' '.join(targets))
 
-        for vname, val in implicit.variables.iteritems():
+        for vname, val in implicit.variables.items():
             self.variables.set(vname,
                                Variables.FLAVOR_SIMPLE,
                                Variables.SOURCE_IMPLICIT, val)
@@ -1750,11 +1746,10 @@ class Makefile(object):
         if value is None:
             self._vpath = []
         else:
-            self._vpath = filter(lambda e: e != '',
-                                 re.split('[%s\s]+' % os.pathsep,
-                                          value.resolvestr(self, self.variables, ['VPATH'])))
+            self._vpath = [e for e in re.split(r'[%s\s]+' % os.pathsep,
+                                          value.resolvestr(self, self.variables, ['VPATH'])) if e != '']
 
-        targets = list(self._targets.itervalues())
+        targets = list(self._targets.values())
         for t in targets:
             t.explicit = True
             for r in t.rules:
@@ -1825,7 +1820,7 @@ class Makefile(object):
 
     def getsubenvironment(self, variables):
         env = dict(self.env)
-        for vname, v in self.exportedvars.iteritems():
+        for vname, v in self.exportedvars.items():
             if v:
                 flavor, source, val = variables.get(vname)
                 if val is None:
